#include <stdio.h>
#include <stdlib.h>
#include  "config.h"

//Global Definitions

MSG m;//Std Message Struct provided by MSG API
MBOX mbox;//If Possible generate automatically on occurance of MESSAGE Obj Def
HANDLE handle;//Handle for Message Box
FLOAT f;//For FLOAT trial

TASK(TASKSNS)
{
printf("Resuming Sensor Thread...\n");
SuspendTask(100);
INT32 cnt=0;
m.idata=100;
SuspendTask(20);
LeoPrint("Resuming Task TASKSND...\n");
for(cnt=0;cnt<40;cnt++){
SuspendTask(10);
LeoPrint("Sending Msg...\n");
SendMessage(handle,m.idata);
m.idata++;
LeoPrint("Suspended Task TASKSND For 40 Clk Ticks=400ms...\n");
SuspendTask(40);
}
}

TASK(TASKMST)
{
printf("Resuming Master Thread...\n");
INT32 cnt=0;
m.idata=10;
LeoPrint("Suspending Task TASKSND For 20 Clk Ticks=200ms...\n");
SuspendTask(20);
LeoPrint("Resuming Task TASKSND...\n");
for(cnt=0;cnt<40;cnt++){
SuspendTask(10);
LeoPrint("Sending Msg...\n");
SendMessage(handle,m.idata);
m.idata++;
LeoPrint("Suspended Task TASKSND For 40 Clk Ticks=400ms...\n");
SuspendTask(40);
}
}

TASK(TASKCTR)
{
printf("Resuming Controler Thread...\n");
INT32 msg;
INT32 cnt=0;
LeoPrint("Suspending Task TASKRCV for 40 Clock Ticks=400ms...\n");
SuspendTask(40);
for(cnt=0;cnt<50;cnt++){
msg=ReceiveMessage(handle);
printf("===\niMESSAGE:%d\n===\n",msg);
SuspendTask(40);
}
}

int main(void){
INT32 mode=0;
printf("Execution Started...\n");
//This is a full proof compulsory step to handle message interface
CreateMessagebox(handle,mbox);
printf("Starting OS & Application....\n");
SuspendTask(200);
StartOS(mode);//jump to OSEK startup
return 0;
}
