#include <stdio.h>
#include <stdlib.h>
#include  "config.h"

//Global Definitions

MSG  m;				//Std Message Struct provided by MSG API
MBOX mbox;			//Message Box1
MBOX mboxc;			//Message Box2
HANDLE handle;			//Handle for Message Box
HANDLE handlec;			//Handle for Thread Message Box
FLOAT f;			//For FLOAT trial

//Y:- STMT: OBJ FUN DEF FOUND.
void
fnTASKSNS (cyg_addrword_t data)
{
    printf ("Resuming Sensor TASK...\n");
    SuspendTask (100);
    m.idata = 100;
    while (1)
      {
	  LeoPrint ("Sensor:Sending Temperature Info...\n");
	  SendMessage (handle, m.idata);
	  SuspendTask (10);
	  m.idata++;
	  LeoPrint ("Sensor:Getting Temperature Info...\n");
      }
}

//Y:- STMT: OBJ FUN DEF FOUND.
void
fnTASKMST (cyg_addrword_t data)
{
    printf ("Resuming Master TASK...\n");
    SuspendTask (100);
    INT32 tmp;
    while (1)
      {
	  tmp = ReceiveMessage (handle);
	  printf ("Master:Sensor Info Received...\n Checking...\n");
	  printf ("Master:Temperature:%d\n===\n", tmp);
	  if (tmp > 110)
	    {
		printf ("Master:Sending Control Signal...\n");
		SendMessage (handlec, tmp);
	    }
	  SuspendTask (10);
      }
}

//Y:- STMT: OBJ FUN DEF FOUND.
void
fnTASKCTR (cyg_addrword_t data)
{
    printf ("Resuming Controller TASK...\n");
    SuspendTask (100);
    INT32 sig;
    while (1)
      {
	  sig = ReceiveMessage (handlec);
	  printf
	      ("Control Signal Received...\n Activating Cooling Mechanism...\n");
	  m.idata = 100;
	  printf ("Controller:Temperature:%d\n===\n", sig);
	  SuspendTask (100);
      }
}

/*Y:- STMT: C FUN DEF FOUND.*/
/*============================*/
int
main (void)
{
    INT32 mode = 0;
    printf ("Execution Started...\nCreating Message Boxes...\n");
    CreateMessagebox (handle, mbox);
    CreateMessagebox (handlec, mboxc);
    printf ("Starting OS & Application....\n");
    SuspendTask (100);
    StartOS (mode);		//jump to OSEK startup
    return 0;

}
